require "defines"
require "util"

--[[
Expansion States:
-peaceful
	Expansion completely disabled
-passive expanding
	Expanding at a minimal pace, keeps away from player base
-aggressive expanding
	Expanding at a more rapid pace, but still keeping away from player base
-beachhead
	Attempts to expand near player base, probably
--]]

game.oninit( function()
	if not glob.AlyxDE_state then
		glob.AlyxDE_state = "peaceful"
	end
	if not glob.AlyxDE_timer then
		glob.AlyxDE_timer = 0
	end
	if not glob.AlyxDE_evolutionReduction then
		glob.AlyxDE_evolutionReduction = .010
	end
	
end)


game.onevent(defines.events.ontick, function(event)

	if (game.tick % (60 * 60)  == 0) and (game.evolutionfactor >= .010) and (glob.AlyxDE_state == "peaceful") then
	
		local expansionChance = math.random(math.floor(game.evolutionfactor * 100), math.floor(game.evolutionfactor * 100) + 100)
		
		if expansionChance >= 100 and expansionChance < 140 then
			AlyxDE_SetExpansionLevel("passive expanding")
			
		elseif expansionChance >= 140 and expansionChance < 190 then
			AlyxDE_SetExpansionLevel("aggressive expanding")
			
		elseif expansionChance >= 190 and expansionChance <= 200 then
			AlyxDE_SetExpansionLevel("beachhead")
			
		end
		
	end
	
	if glob.AlyxDE_state ~= "peaceful" then
		if glob.AlyxDE_timer > 0 then
			glob.AlyxDE_timer = glob.AlyxDE_timer - 1

		else
			AlyxDE_SetExpansionLevel("peaceful")
		end
		
	end

end)

function AlyxDE_SetExpansionLevel(expansionState)
	expansionState = expansionState or "peaceful"
	
	if expansionState == "peaceful" then
		game.mapsettings.enemy_expansion.enabled = false
		glob.AlyxDE_timer = 0
		
		if glob.AlyxDE_state == "passive expanding" then
			game.evolutionfactor = game.evolutionfactor - .001
		elseif glob.AlyxDE_state == "aggressive expanding" then
			game.evolutionfactor = game.evolutionfactor - .0015
		elseif glob.AlyxDE_state == "beachhead" then
			game.evolutionfactor = game.evolutionfactor - .0025
		end
		
		if game.evolutionfactor < .01 then
			game.evolutionfactor = .01
		end
	
	elseif expansionState == "passive expanding" then
		game.mapsettings.enemy_expansion.enabled = true
		glob.AlyxDE_timer = math.random(2 * 3600, 5 * 3600)
			game.mapsettings.enemy_expansion.min_base_spacing = 4
			game.mapsettings.enemy_expansion.max_expansion_distance = 6
			game.mapsettings.enemy_expansion.min_player_base_distance = 10
			game.mapsettings.enemy_expansion.settler_group_min_size = 4
			game.mapsettings.enemy_expansion.settler_group_max_size = 8
			game.mapsettings.enemy_expansion.min_expansion_cooldown = 10 * 60
			game.mapsettings.enemy_expansion.max_expansion_cooldown = 30 * 60
	
	elseif expansionState == "aggressive expanding" then
		game.mapsettings.enemy_expansion.enabled = true
		glob.AlyxDE_timer = math.random(1.5 * 3600, 4 * 3600)
			game.mapsettings.enemy_expansion.min_base_spacing = 3
			game.mapsettings.enemy_expansion.max_expansion_distance = 8
			game.mapsettings.enemy_expansion.min_player_base_distance = 6
			game.mapsettings.enemy_expansion.settler_group_min_size = 15
			game.mapsettings.enemy_expansion.settler_group_max_size = 30
			game.mapsettings.enemy_expansion.min_expansion_cooldown = 5 * 60
			game.mapsettings.enemy_expansion.max_expansion_cooldown = 25 * 60
		
	elseif expansionState == "beachhead" then
		game.mapsettings.enemy_expansion.enabled = true
		glob.AlyxDE_timer = math.random(1 * 3600, 3 * 3600)
			game.mapsettings.enemy_expansion.min_base_spacing = 6
			game.mapsettings.enemy_expansion.max_expansion_distance = 30
			game.mapsettings.enemy_expansion.min_player_base_distance = 0
			game.mapsettings.enemy_expansion.settler_group_min_size = 40
			game.mapsettings.enemy_expansion.settler_group_max_size = 100
			game.mapsettings.enemy_expansion.min_expansion_cooldown = 5 * 60
			game.mapsettings.enemy_expansion.max_expansion_cooldown = 20 * 60
	
	end
	
	glob.AlyxDE_state = expansionState
	--game.player.print("Expansion state set to: " .. glob.AlyxDE_state)
	--game.player.print("Timer is: " .. (glob.AlyxDE_timer / 60) .. " seconds")
end